zoukankan      html  css  js  c++  java
  • LeetCode 568. Maximum Vacation Days

    原题链接在这里:https://leetcode.com/problems/maximum-vacation-days/

    题目:

    LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

    Rules and restrictions:

    1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
    2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
    3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
    4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

    You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

    Example 1:

    Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
    Output: 12
    Explanation: 
    Ans = 6 + 3 + 3 = 12.
    One of the best strategies is: 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
    (Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days. 3rd week : stay at city 2, and play 3 days and work 4 days.

    Example 2:

    Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
    Output: 3
    Explanation: 
    Ans = 1 + 1 + 1 = 3.
    Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
    For each week, you only have one day to play and six days to work.
    So the maximum number of vacation days is 3.

    Example 3:

    Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
    Output: 21
    Explanation:
    Ans = 7 + 7 + 7 = 21
    One of the best strategies is: 1st week : stay at city 0, and play 7 days. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

    Note:

    1. N and K are positive integers, which are in the range of [1, 100].
    2. In the matrix flights, all the values are integers in the range of [0, 1].
    3. In the matrix days, all the values are integers in the range [0, 7].
    4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
    5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
    6. We don't consider the impact of flight hours towards the calculation of vacation days.

    题解:

    Let dp[i][j] denotes at jth week, staying at ith city, the maximum vacation days.

    For the next week, check previous week, if (staying in the same city || different city with a flight) && previous city could be reached, update the maximum vacation days.

    For result, check last last week, all cities, get the maximum value.

    Note: use capital for const value.

    Time Complexity: O(K*N^2).

    Space: O(K*N). Could optimize space.

    AC Java:

     1 class Solution {
     2     public int maxVacationDays(int[][] flights, int[][] days) {
     3         int N = days.length;
     4         int K = days[0].length;
     5         int [][] dp = new int[N][K];
     6         for(int i = 0; i<N; i++){
     7             Arrays.fill(dp[i], -1);
     8         }
     9         
    10         for(int i = 0; i<N; i++){
    11             if(i == 0 || flights[0][i] == 1){
    12                 dp[i][0] = days[i][0];
    13             }
    14         }
    15         
    16         for(int j = 1; j<K; j++){
    17             for(int i = 0; i<N; i++){
    18                 for(int p = 0; p<N; p++){
    19                     if((p == i || flights[p][i] == 1) && dp[p][j-1] >= 0){
    20                         dp[i][j] = Math.max(dp[i][j], dp[p][j-1] + days[i][j]);
    21                     }
    22                 }
    23             }
    24         }
    25         
    26         int res = 0;
    27         for(int i = 0; i<N; i++){
    28             res = Math.max(res, dp[i][K-1]);
    29         }
    30         
    31         return res;
    32     }
    33 }
  • 相关阅读:
    processon--工作中画业务流程图很好的网站,欢迎推荐
    项目中关于RPC 和rocketMQ使用场景的感受
    如何永久激活(破解) IntelliJ IDEA 2018.2
    js生成二维码
    序列化反序列化
    bootstrap-treeview分级展示列表树的实现
    关于redis分布式锁实现原理
    LocalDate
    html css javascript mysql php学习总结
    JQuery中$.ajax()方法参数详解
  • 原文地址:https://www.cnblogs.com/Dylan-Java-NYC/p/12042150.html
Copyright © 2011-2022 走看看